import type { CallbackFn } from '../types';
/**
 * A custom hook that converts a callback to a ref to avoid triggering re-renders
 * ..when passed as a prop or avoid re-executing effects when passed as a dependency
 *
 * @param callback The callback to write to a ref object
 */
declare const useCallbackRef: <T extends CallbackFn>(callback: T | undefined) => T;
export default useCallbackRef;
