import type { MenuOption } from './Select';
import type { ReactNode, MouseEvent, TouchEvent, EventHandler } from 'react';
export declare type OptionData = any;
export declare type CallbackFn = (...args: any[]) => any;
export declare type AriaLiveAttribute = 'off' | 'polite' | 'assertive';
export declare type CustomRendererCallback = (...args: any[]) => ReactNode;
export declare type IconRenderer = ReactNode | CustomRendererCallback;
export declare type OptionValueCallback = (data: OptionData) => string | number;
export declare type OptionLabelCallback = OptionValueCallback;
export declare type RenderLabelCallback = (data: OptionData) => ReactNode;
export declare type OptionFilterCallback = (option: MenuOption) => string;
export declare type OptionDisabledCallback = (data: OptionData) => boolean;
export declare type MouseOrTouchEvent<T = Element> = MouseEvent<T> | TouchEvent<T>;
export declare type MouseOrTouchEventHandler<T = Element> = EventHandler<MouseOrTouchEvent<T>>;
export declare type TestableElement = {
    'data-testid'?: string;
};
export declare type PartialDeep<T> = {
    [P in keyof T]?: PartialDeep<T[P]>;
};
export declare type SelectedOption = {
    data?: OptionData;
    value?: string | number;
    label?: string | number;
};
export interface FocusedOption extends SelectedOption {
    index: number;
    isDisabled?: boolean;
    isSelected?: boolean;
}
export declare type ItemData = {
    memoOptions: boolean;
    menuOptions: MenuOption[];
    focusedOptionIndex: number;
    renderOptionLabel: (data: OptionData) => ReactNode;
    selectOption: (option: SelectedOption, isSelected?: boolean) => void;
};
