import type { SyntheticEvent } from 'react';
import type { SelectedOption, OptionValueCallback, OptionLabelCallback, CallbackFn } from '../types';
export declare const isBoolean: (val: unknown) => val is boolean;
export declare const isFunction: (val: unknown) => val is CallbackFn;
export declare const isArrayWithLength: (val: unknown) => boolean;
export declare const isPlainObject: (val: unknown) => boolean;
/**
 * Call preventDefault() and stopPropagation() on event.
 */
export declare const suppressEvent: (e: SyntheticEvent<Element>) => void;
/**
 * Apply regex to string, and if the value is NOT case sensitive,
 * call .toLowerCase() and return result.
 */
export declare const trimAndFormatFilterStr: (value: string, filterIgnoreCase: boolean, filterIgnoreAccents: boolean) => string;
/**
 * Builds the className property in Option.tsx component.
 */
export declare const buildOptionClsName: (isDisabled: boolean, isSelected: boolean, isFocused: boolean) => string;
/**
 * Parses an object or an array of objects into output of SelectedOption[].
 */
export declare const normalizeValue: (value: unknown, getOptionValue: OptionValueCallback, getOptionLabel: OptionLabelCallback) => SelectedOption[];
/**
 * Immutable implementation of mergeDeep for two objects. Will return the merged result.
 * In first condition of if/else block - check that property is no 'animation',
 * since we never want to merge that complex styled-component object.
 */
export declare const mergeDeep: <T>(target: any, source: any) => T;
